/* this file is a part of amp software, (C) tomislav uzelac 1996,1997
*/
 
/* huffman.h  
 * 	      
 * Created by: tomislav uzelac  Mar 1996
 */
 
struct LINK {
        char x,y;
        struct LINK *p0,*p1; };

extern int huffman_create(FILE *table_file,struct LINK *target);
extern int huffman_decode(int tbl,int *x,int *y);
extern void huffman_init(void);

#ifdef HUFFMAN

int huffman_create(FILE *table_file,struct LINK *target);
int huffman_decode(int tbl,int *x,int *y);
void huffman_init(void);

static int get_value(FILE *stream,char *out);
static inline struct LINK *follow_link(struct LINK *active,char symbol);
static inline void create_link(int x,int y,struct LINK *append,struct LINK *active,char symbol);
static inline int get_symbol(FILE *stream);

static char symbol;
static struct LINK *t_huf[34];
static char *t_tab[34]={"h0","h1","h2","h3",0,"h5","h6",
			"h7","h8","h9","h10","h11","h12",
			"h13",0,"h15","h16",0,0,0,0,0,0,0,
			"h24",0,0,0,0,0,0,0,"hqa","hqb"};
static int t_hufsize[34]={0,7,17,17,0,31,31,71,71,71,127,127,127,511,0,511,
			  511,0,0,0,0,0,0,0,511,0,0,0,0,0,0,0,31,31};
/* static int t_linbits[34]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,6,8,10,13,
			  4,5,6,7,8,9,11,13,0,0};*/			 
#endif /* HUFFMAN */
